'BY ATOMIZER_ZERO
OPTION EXPLICIT
OPTION BASE 1
OPTION DEFAULT INTEGER
OPTION CONSOLE serial
MODE 6, 12

#INCLUDE "MAP.INC"
#INCLUDE "CONTROLINPUT.INC"

'WORLD VARIABLES
DIM LEVEL(17,12) 'ARRAY FOR STORING CURRENT LEVEL DATA
DIM INTEGER ID = 1 'LEVEL IDS ; 1 IS TEMP
DIM INTEGER X = 0 'GENERAL PURPOSE X
DIM INTEGER Y = 0 'GENERAL PURPOSE Y
DIM COLLISIONMAP(33,23)


CONST OVERWORLD = 0 'PAGE 0 - BACKGROUND TILE DRAWING
CONST SPRITEPAGE = 1 'PAGE 1 - FOREGROND SPRITE DRAWING
CONST SPRITECOPYPAGE = 2 'PAGE 2 - DRAW TO THIS PAGE, THEN COPY TO SPRITEPAGE
CONST SPRITETILESET = 3 'PAGE 3 - SPRITE TILESET
CONST OVERWORLDTILESET = 4 'PAGE 4 - OVERWORLD TILESET
CONST DUNGEONTILESET = 5 'PAGE 5 - UNDERWORLD TILESET

FOR X = 0 TO 13
  PAGE WRITE X : CLS
NEXT X

DIM INTEGER TILE = 0 'TILE BEING READ, FOR DRAWING
DIM INTEGER DIRECTION = 0 'DIRECTION OF MAP TRAVERSAL

'SPRITE VARIABLES
DIM INTEGER LINK = 1
DIM INTEGER MOBLIN = 2
DIM INTEGER DARKNUT = 3

DIM LINKFRAMES(4,3) ' 4 DIRECTIONS, 3 FRAMES

'PLAYER VARIABLES
DIM INTEGER STARTLOCATION = 128
DIM INTEGER PLAYERX = STARTLOCATION
DIM INTEGER PLAYERY = STARTLOCATION
CONST SPEED = 1
DIM PLAYERHITBOX(4,2) '4 POSITIONS, X AND Y. (X+4)(Y+8), (X+12)(Y+8), (X+4)(Y+16), (X+12)(Y+16)

'SCREEN VARIABLES
CONST ROOMLEFT = 0
CONST ROOMRIGHT = 256
CONST ROOMTOP = 64
CONST ROOMBOTTOM = 240

'COLLISION VARIABLES
DIM INTEGER COLLIDE = 0
'DIM INTEGER COLLISION = 0
DIM INTEGER XOFFS = 1
DIM INTEGER YOFFS = 1
DIM INTEGER TILECOL = 0
DIM TILEHITBOX(4,2) '4 POSITIONS, X AND Y
DIM INTEGER TILETL, TILETR, TILEBL, TILEBR

'WRITE TILESET TO PAGE
PAGE WRITE OVERWORLDTILESET : CLS
LOAD PNG "ZELDAOW.PNG"
IMAGE RESIZE_FAST 0,0, 96, 56, 0, 0, 96*2, 56*2, OVERWORLDTILESET

PAGE WRITE SPRITETILESET : CLS
LOAD PNG "SPRITES.PNG" ,0,0,15
IMAGE RESIZE_FAST 0,0, 96, 80, 0, 0, 96*2, 80*2, SPRITETILESET

SPRITE READ LINK, 32,0,16,16
sprite read darknut, 32,96,16,16 

DIM INTEGER ANIMATETIME
DIM INTEGER ANIMATEFRAME
DIM INTEGER TEMPFRAME
DIM INTEGER SPR, NUMFRAMES,SPRPOSX, SPRPOSY ' SPR = SPRITE ID/NAME, NUMBER OF FRAME, POS OF SPR X/Y

'SPRITE, DIRECTION, NUMOFFRAMES, POSITION ON SPRITESHEET X AND Y
SUB ANIMATE(SPR, NUMFRAMES, SPRPOSX, SPRPOSY)
  IF TIMER - ANIMATETIME > 100 THEN
    ANIMATETIME = TIMER
    ANIMATEFRAME = ANIMATEFRAME + 1
      IF ANIMATEFRAME > NUMFRAMES THEN 
        ANIMATEFRAME = 1 
      END IF
    END IF
  SPRITE READ SPR, SPRPOSX, SPRPOSY+(ANIMATEFRAME*16)-16, 16,16, SPRITETILESET
END SUB
'PAGE WRITE SPRITECOPYPAGE
'SPRITE SHOW LINK, PLAYERX, PLAYERY, SPRITECOPYPAGE
'PAGE COPY SPRITECOPYPAGE, SPRITEPAGE,B



'READ DATA FROM MAP
SUB READLEVEL(ID)
  SELECT CASE ID
    CASE 1  : RESTORE A1 
    CASE 2  : RESTORE A2
    CASE 3  : RESTORE A3
    CASE 4  : RESTORE A4
    CASE 5  : RESTORE A5
    CASE 6  : RESTORE A6
    CASE 7  : RESTORE A7
    CASE 8  : RESTORE A8
    CASE 9  : RESTORE A9
    CASE 10 : RESTORE A10
    CASE 11 : RESTORE A11
    CASE 12 : RESTORE A12
    CASE 13 : RESTORE A13
    CASE 14 : RESTORE A14
    CASE 15 : RESTORE A15
    CASE 16 : RESTORE A16
    CASE 17 : RESTORE B1
    CASE 18 : RESTORE B2
    CASE 19 : RESTORE B3
    CASE 20 : RESTORE B4
    CASE 21 : RESTORE B5
    CASE 22 : RESTORE B6
    CASE 23 : RESTORE B7
    CASE 24 : RESTORE B8
    CASE 25 : RESTORE B9
    CASE 26 : RESTORE B10
    CASE 27 : RESTORE B11
    CASE 28 : RESTORE B12
    CASE 29 : RESTORE B13
    CASE 30 : RESTORE B14
    CASE 31 : RESTORE B15
    CASE 32 : RESTORE B16
    CASE 33 : RESTORE C1
    CASE 34 : RESTORE C2
    CASE 35 : RESTORE C3
    CASE 36 : RESTORE C4
    CASE 37 : RESTORE C5
    CASE 38 : RESTORE C6
    CASE 39 : RESTORE C7
    CASE 40 : RESTORE C8
    CASE 41 : RESTORE C9
    CASE 42 : RESTORE C10
    CASE 43 : RESTORE C11
    CASE 44 : RESTORE C12
    CASE 45 : RESTORE C13
    CASE 46 : RESTORE C14
    CASE 47 : RESTORE C15
    CASE 48 : RESTORE C16
    CASE 49 : RESTORE D1
    CASE 40 : RESTORE D2
    CASE 51 : RESTORE D3
    CASE 52 : RESTORE D4
    CASE 53 : RESTORE D5
    CASE 54 : RESTORE D6
    CASE 55 : RESTORE D7
    CASE 56 : RESTORE D8
    CASE 57 : RESTORE D9
    CASE 58 : RESTORE D10
    CASE 59 : RESTORE D11
    CASE 60 : RESTORE D12
    CASE 61 : RESTORE D13
    CASE 62 : RESTORE D14
    CASE 63 : RESTORE D15
    CASE 64 : RESTORE D16
    CASE 65 : RESTORE E1
    CASE 66 : RESTORE E2
    CASE 67 : RESTORE E3
    CASE 68 : RESTORE E4
    CASE 69 : RESTORE E5
    CASE 70 : RESTORE E6
    CASE 71 : RESTORE E7
    CASE 72 : RESTORE E8
    CASE 73 : RESTORE E9
    CASE 74 : RESTORE E10
    CASE 75 : RESTORE E11
    CASE 76 : RESTORE E12
    CASE 77 : RESTORE E13
    CASE 78 : RESTORE E14
    CASE 79 : RESTORE E15
    CASE 80 : RESTORE E16
    CASE 81 : RESTORE F1
    CASE 82 : RESTORE F2
    CASE 83 : RESTORE F3
    CASE 84 : RESTORE F4
    CASE 85 : RESTORE F5
    CASE 86 : RESTORE F6
    CASE 87 : RESTORE F7
    CASE 88 : RESTORE F8
    CASE 89 : RESTORE F9
    CASE 90 : RESTORE F10
    CASE 91 : RESTORE F11
    CASE 92 : RESTORE F12
    CASE 93 : RESTORE F13
    CASE 94 : RESTORE F14
    CASE 95 : RESTORE F15
    CASE 96 : RESTORE F16
    CASE 97 : RESTORE G1
    CASE 98 : RESTORE G2
    CASE 99 : RESTORE G3
    CASE 100: RESTORE G4
    CASE 101: RESTORE G5
    CASE 102: RESTORE G6
    CASE 103: RESTORE G7
    CASE 104: RESTORE G8
    CASE 105: RESTORE G9
    CASE 106: RESTORE G10
    CASE 107: RESTORE G11
    CASE 108: RESTORE G12
    CASE 109: RESTORE G13
    CASE 110: RESTORE G14
    CASE 111: RESTORE G15
    CASE 112: RESTORE G16
    CASE 113: RESTORE H1
    CASE 114: RESTORE H2
    CASE 115: RESTORE H3
    CASE 116: RESTORE H4
    CASE 117: RESTORE H5
    CASE 118: RESTORE H6
    CASE 119: RESTORE H7
    CASE 120: RESTORE H8
    CASE 121: RESTORE H9
    CASE 122: RESTORE H10
    CASE 123: RESTORE H11
    CASE 124: RESTORE H12
    CASE 125: RESTORE H13
    CASE 126: RESTORE H14
    CASE 127: RESTORE H15
    CASE 128: RESTORE H16
  END SELECT

FOR Y = 1 TO 11 
  FOR X = 1 TO 16
    READ LEVEL(X, Y)
  NEXT X
NEXT Y

READCOLLISIONMAP()

END SUB

SUB READCOLLISIONMAP
  FOR Y = 1 TO 11
    FOR X = 1 TO 16
      TILECOL = LEVEL(X,Y)
        SELECT CASE TILECOL
          CASE 0 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 1 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 2 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 3 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 4 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 5 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 6 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 7 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 8 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 9 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 10 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 11 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 12 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 13 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 14 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 15 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 16 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 17 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 18 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 19 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 20 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 21 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 22 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 23 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          
          CASE 24 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 25 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 26 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 27 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 28 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 29 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 30 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 31 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 32 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 33 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 34 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 35 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          
          CASE 36 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 37 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 38 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 39 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 40 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 41 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 42 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 43 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 44 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 45 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 46 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 47 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          
          CASE 48 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 49 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 50 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 51 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 52 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0
          CASE 53 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 54 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 55 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1
          CASE 56 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1  
          CASE 57 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0 
          CASE 58 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0            
          CASE 59 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 60 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 61 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 62 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 63 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0            
          CASE 64 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 65 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 66 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 67 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 68 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 69 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0            
          CASE 70 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 71 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 72 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 73 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 74 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 75 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0            
          CASE 76 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0            
          CASE 77 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 78 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 79 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 80 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE 81 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0            
          CASE 82 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0            
          CASE 83 :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 1
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 1
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 1            
          CASE ELSE :
            COLLISIONMAP(2*(X) - 1, 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X)    , 2*(Y) - 1) = 0
            COLLISIONMAP(2*(X) - 1, 2*(Y)    ) = 0
            COLLISIONMAP(2*(X)    , 2*(Y)    ) = 0   
        END SELECT
    NEXT X
  NEXT Y
END SUB

'DRAWTILES SUB
SUB DRAWTILES(TILE, X, Y)
PAGE WRITE OVERWORLD
    SELECT CASE TILE
      CASE 0  : BLIT 0  , 0 , X, Y, 16,16,OVERWORLDTILESET
      CASE 1  : BLIT 16 , 0 , X, Y, 16,16,OVERWORLDTILESET
      CASE 2  : BLIT 32 , 0 , X, Y, 16,16,OVERWORLDTILESET
      CASE 3  : BLIT 48 , 0 , X, Y, 16,16,OVERWORLDTILESET
      CASE 4  : BLIT 64 , 0 , X, Y, 16,16,OVERWORLDTILESET
      CASE 5  : BLIT 80 , 0 , X, Y, 16,16,OVERWORLDTILESET
      CASE 6  : BLIT 96 , 0 , X, Y, 16,16,OVERWORLDTILESET
      CASE 7  : BLIT 112, 0 , X, Y, 16,16,OVERWORLDTILESET
      CASE 8  : BLIT 128, 0 , X, Y, 16,16,OVERWORLDTILESET
      CASE 9  : BLIT 144, 0 , X, Y, 16,16,OVERWORLDTILESET
      CASE 10 : BLIT 160, 0 , X, Y, 16,16,OVERWORLDTILESET
      CASE 11 : BLIT 176, 0 , X, Y, 16,16,OVERWORLDTILESET
   
      CASE 12 : BLIT 0  , 16, X, Y, 16,16,OVERWORLDTILESET
      CASE 13 : BLIT 16 , 16, X, Y, 16,16,OVERWORLDTILESET
      CASE 14 : BLIT 32 , 16, X, Y, 16,16,OVERWORLDTILESET
      CASE 15 : BLIT 48 , 16, X, Y, 16,16,OVERWORLDTILESET
      CASE 16 : BLIT 64 , 16, X, Y, 16,16,OVERWORLDTILESET
      CASE 17 : BLIT 80 , 16, X, Y, 16,16,OVERWORLDTILESET
      CASE 18 : BLIT 96 , 16, X, Y, 16,16,OVERWORLDTILESET
      CASE 19 : BLIT 112, 16, X, Y, 16,16,OVERWORLDTILESET
      CASE 20 : BLIT 128, 16, X, Y, 16,16,OVERWORLDTILESET
      CASE 21 : BLIT 144, 16, X, Y, 16,16,OVERWORLDTILESET
      CASE 22 : BLIT 160, 16, X, Y, 16,16,OVERWORLDTILESET
      CASE 23 : BLIT 176, 16, X, Y, 16,16,OVERWORLDTILESET
      
      CASE 24 : BLIT 0  , 32, X, Y, 16,16,OVERWORLDTILESET
      CASE 25 : BLIT 16 , 32, X, Y, 16,16,OVERWORLDTILESET
      CASE 26 : BLIT 32 , 32, X, Y, 16,16,OVERWORLDTILESET
      CASE 27 : BLIT 48 , 32, X, Y, 16,16,OVERWORLDTILESET
      CASE 28 : BLIT 64 , 32, X, Y, 16,16,OVERWORLDTILESET
      CASE 29 : BLIT 80 , 32, X, Y, 16,16,OVERWORLDTILESET
      CASE 30 : BLIT 96 , 32, X, Y, 16,16,OVERWORLDTILESET
      CASE 31 : BLIT 112, 32, X, Y, 16,16,OVERWORLDTILESET
      CASE 32 : BLIT 128, 32, X, Y, 16,16,OVERWORLDTILESET
      CASE 33 : BLIT 144, 32, X, Y, 16,16,OVERWORLDTILESET
      CASE 34 : BLIT 160, 32, X, Y, 16,16,OVERWORLDTILESET
      CASE 35 : BLIT 176, 32, X, Y, 16,16,OVERWORLDTILESET

      CASE 36 : BLIT 0  , 48, X, Y, 16,16,OVERWORLDTILESET
      CASE 37 : BLIT 16 , 48, X, Y, 16,16,OVERWORLDTILESET
      CASE 38 : BLIT 32 , 48, X, Y, 16,16,OVERWORLDTILESET
      CASE 39 : BLIT 48 , 48, X, Y, 16,16,OVERWORLDTILESET
      CASE 40 : BLIT 64 , 48, X, Y, 16,16,OVERWORLDTILESET
      CASE 41 : BLIT 80 , 48, X, Y, 16,16,OVERWORLDTILESET
      CASE 42 : BLIT 96 , 48, X, Y, 16,16,OVERWORLDTILESET
      CASE 43 : BLIT 112, 48, X, Y, 16,16,OVERWORLDTILESET
      CASE 44 : BLIT 128, 48, X, Y, 16,16,OVERWORLDTILESET
      CASE 45 : BLIT 144, 48, X, Y, 16,16,OVERWORLDTILESET
      CASE 46 : BLIT 160, 48, X, Y, 16,16,OVERWORLDTILESET
      CASE 47 : BLIT 176, 48, X, Y, 16,16,OVERWORLDTILESET

      CASE 48 : BLIT 0  , 64, X, Y, 16,16,OVERWORLDTILESET
      CASE 49 : BLIT 16 , 64, X, Y, 16,16,OVERWORLDTILESET
      CASE 50 : BLIT 32 , 64, X, Y, 16,16,OVERWORLDTILESET
      CASE 51 : BLIT 48 , 64, X, Y, 16,16,OVERWORLDTILESET
      CASE 52 : BLIT 64 , 64, X, Y, 16,16,OVERWORLDTILESET
      CASE 53 : BLIT 80 , 64, X, Y, 16,16,OVERWORLDTILESET
      CASE 54 : BLIT 96 , 64, X, Y, 16,16,OVERWORLDTILESET
      CASE 55 : BLIT 112, 64, X, Y, 16,16,OVERWORLDTILESET
      CASE 56 : BLIT 128, 64, X, Y, 16,16,OVERWORLDTILESET
      CASE 57 : BLIT 144, 64, X, Y, 16,16,OVERWORLDTILESET
      CASE 58 : BLIT 160, 64, X, Y, 16,16,OVERWORLDTILESET
      CASE 59 : BLIT 176, 64, X, Y, 16,16,OVERWORLDTILESET

      CASE 60 : BLIT 0  , 80, X, Y, 16,16,OVERWORLDTILESET
      CASE 61 : BLIT 16 , 80, X, Y, 16,16,OVERWORLDTILESET
      CASE 62 : BLIT 32 , 80, X, Y, 16,16,OVERWORLDTILESET
      CASE 63 : BLIT 48 , 80, X, Y, 16,16,OVERWORLDTILESET
      CASE 64 : BLIT 64 , 80, X, Y, 16,16,OVERWORLDTILESET
      CASE 65 : BLIT 80 , 80, X, Y, 16,16,OVERWORLDTILESET
      CASE 66 : BLIT 96 , 80, X, Y, 16,16,OVERWORLDTILESET
      CASE 67 : BLIT 112, 80, X, Y, 16,16,OVERWORLDTILESET
      CASE 68 : BLIT 128, 80, X, Y, 16,16,OVERWORLDTILESET
      CASE 69 : BLIT 144, 80, X, Y, 16,16,OVERWORLDTILESET
      CASE 70 : BLIT 160, 80, X, Y, 16,16,OVERWORLDTILESET
      CASE 71 : BLIT 176, 80, X, Y, 16,16,OVERWORLDTILESET
 
      CASE 72 : BLIT 0  , 96, X, Y, 16,16,OVERWORLDTILESET
      CASE 73 : BLIT 16 , 96, X, Y, 16,16,OVERWORLDTILESET
      CASE 74 : BLIT 32 , 96, X, Y, 16,16,OVERWORLDTILESET
      CASE 75 : BLIT 48 , 96, X, Y, 16,16,OVERWORLDTILESET
      CASE 76 : BLIT 64 , 96, X, Y, 16,16,OVERWORLDTILESET
      CASE 77 : BLIT 80 , 96, X, Y, 16,16,OVERWORLDTILESET
      CASE 78 : BLIT 96 , 96, X, Y, 16,16,OVERWORLDTILESET
      CASE 79 : BLIT 112, 96, X, Y, 16,16,OVERWORLDTILESET
      CASE 80 : BLIT 128, 96, X, Y, 16,16,OVERWORLDTILESET
      CASE 81 : BLIT 144, 96, X, Y, 16,16,OVERWORLDTILESET
      CASE 82 : BLIT 160, 96, X, Y, 16,16,OVERWORLDTILESET
      CASE 83 : BLIT 176, 96, X, Y, 16,16,OVERWORLDTILESET
    END SELECT
END SUB

'TEMPORARY SUB TO PASS DIRECTION THROUGH SUBS TO SCROLL SCREEN
SUB LOADLEVEL(DIRECTION)
scroll(direction)
END SUB

'SCROLL THE SCREEN IN THE DIRECTION YOU ARE MOVING
sub scroll(direction)
select case direction
  case 1 : ' up
    for y = 11 to 1 step -1
    page scroll 0,0,-16,-1
    scrollplayer(1)
      pause(32)
      for x = 1 to 16 
        tile = level(x,y)
        drawtiles(tile, ((x*16) - 16), 64 - ((y * 16) - (y*16)))
      next x
    next y
    TILE8COLLIDE()
  case 2: 'right
    for x = 1 to 16
    page scroll 0,-16,0,-1
    scrollplayer(2)
      pause(32)
      for y = 1 to 11 
        tile = level(x,y)
        drawtiles(tile, (240 + (x*16) - (x*16)), (y*16) +48)
      next y
    next x
    TILE8COLLIDE()
  case 3 : 'down
    for y = 1 to 11
    page scroll 0,0,16,-1
    scrollplayer(3)
      pause(32)
      for x = 1 to 16
        tile = level(x,y)
        drawtiles(tile, ((x*16) - 16), 224 + (y * 16) - (y*16))
      next x
    next y
    TILE8COLLIDE()
  case 4: 'left
    for x = 16 to 1 step -1
    page scroll 0,16,0,-1
    scrollplayer(4)
      pause(32)
      for y = 1 to 11 
          tile = level(x,y)
          drawtiles(tile, ((x*16) - (x*16)), (y*16) +48)
      next y
    next x
    TILE8COLLIDE()
end select           
end sub

SUB CHECKSTUCK(DIRECTION)
  SELECT CASE DIRECTION
  CASE 1 :
    FOR X = 1 TO 8
    TILE8COLLIDE()
    IF COLLIDE THEN
      IF PLAYERX > 80 AND PLAYERX < 112 THEN
        PLAYERX = PLAYERX + 1
      ELSE IF PLAYERX > 140 AND PLAYERX < 160  THEN
        PLAYERX = PLAYERX - 1
      END IF
    END IF   
    NEXT X
  CASE 2 :
    FOR X = 1 TO 8
    TILE8COLLIDE()
    IF COLLIDE THEN
      IF PLAYERY < 120 THEN
        PLAYERY = PLAYERY + 1
      ELSE IF PLAYERY > 140 THEN
        PLAYERY = PLAYERY - 1
      END IF
    END IF  
    NEXT X
  CASE 3 :
    FOR X = 1 TO 8
    TILE8COLLIDE()
    IF COLLIDE THEN
      IF PLAYERX > 80 AND PLAYERX < 112 THEN
        PLAYERX = PLAYERX + 1
      ELSE IF PLAYERX > 140 AND PLAYERX < 160 THEN
        PLAYERX = PLAYERX - 1
      END IF
    END IF  
    NEXT X
  CASE 4 :
    FOR X = 1 TO 8
    TILE8COLLIDE()
    IF COLLIDE THEN
      IF PLAYERY < 120 THEN
        PLAYERY = PLAYERY + 1
      ELSE IF PLAYERY > 140 THEN
        PLAYERY = PLAYERY - 1
      END IF
    END IF  
    NEXT X
  END SELECT
END SUB

'DRAW INITIAL SCREEN (TEMP)
PAGE WRITE OVERWORLD
READLEVEL(ID)
LOADLEVEL()      
FOR Y = 1 TO 11
  FOR X = 1 TO 16
    TILE = LEVEL(X,Y)
    DRAWTILES(TILE, ((X*16) - 16), ((Y*16)) + 48)
  NEXT X
NEXT Y

'DRAW BLACK BOX TOP OF SCREEN - temp until implemented proper.
Page write SPRITECOPYPAGE
box  0,0, mm.hres, 64, 0, RGB(1,1,1),RGB(1,1,1)
DIM INTEGER OLDPOSX, OLDPOSY

SUB SPRITECOLLIDE(DIRECTION)
  PLAYERY = OLDPOSY
  PLAYERX = OLDPOSX
END SUB

'##########################################################################
DO
OLDPOSY = PLAYERY
OLDPOSX = PLAYERX

PAGE WRITE SPRITECOPYPAGE
SPRITE SHOW LINK, PLAYERX, PLAYERY, 0
sprite show darknut, 100, 100, 0
PAGE COPY SPRITECOPYPAGE, SPRITEPAGE,B

ANIMATE(DARKNUT,2,32,96)
KEYINPUT()

PLAYERUPDATEX(DIRECTION)
UPDATEPLAYERHITBOX()
TILE8COLLIDE()

IF(COLLIDE = 1) THEN
  PLAYERX = OLDPOSX
END IF

PLAYERUPDATEY(DIRECTION)
UPDATEPLAYERHITBOX()
TILE8COLLIDE()

IF(COLLIDE = 1) THEN 
  PLAYERY = OLDPOSY
END IF

COLLISION(SPR)

'GETCOLLISIONBOX()

GETTILESTANDING
'WALLCOLLISION(TILECOL)
'GETCOLLIDING(TILECOL, XOFFS, YOFFS)
?@(0,0)OLDPOSX, OLDPOSY, PLAYERX, PLAYERY, XOFFS, YOFFS, ((XOFFS-1)*16), ((YOFFS+3)*16)
ROOMEDGEHIT()
LOOP
'###########################################################################

SUB COLLISION(SPR)
  LOCAL INTEGER I
    IF SPRITE(S) <> 0 THEN
      PRINT "COLLISION ON SPRITE", SPRITE(S)
    END IF
END SUB


SUB PLAYERUPDATEY(DIRECTION)
  IF UPPRESS    THEN : DIRECTION = 1 : PLAYERY = PLAYERY - SPEED : ANIMATE(LINK,2, 0, 0) : END IF
  IF DOWNPRESS  THEN : DIRECTION = 3 : PLAYERY = PLAYERY + SPEED : ANIMATE(LINK,2,32, 0) : END IF
END SUB

SUB PLAYERUPDATEX(DIRECTION)
  IF RIGHTPRESS THEN : DIRECTION = 2 : PLAYERX = PLAYERX + SPEED : ANIMATE(LINK,2,16, 0) : END IF
  IF LEFTPRESS  THEN : DIRECTION = 4 : PLAYERX = PLAYERX - SPEED : ANIMATE(LINK,2,48, 0) : END IF
END SUB

FUNCTION ROUND8(INNUM AS INTEGER)
  IF (UPPRESS AND DIRECTION <> 1) OR (DOWNPRESS AND DIRECTION <> 3) OR (LEFTPRESS AND DIRECTION <> 4) OR (RIGHTPRESS AND DIRECTION <> 2) THEN
    TEXT 128,16, "TRUE "
    IF (INNUM MOD(8) > 8/2) THEN
      ROUND8 = INNUM + 8 - INNUM MOD(8)
    ELSE
      ROUND8 = INNUM - INNUM MOD(8)
    END IF
  ELSE 
    TEXT 128,16, "FALSE "
    ROUND8 = INNUM
  END IF
END FUNCTION


SUB UPDATEPLAYERHITBOX
'(X+4)(Y+8), (X+12)(Y+8), (X+4)(Y+16), (X+12)(Y+16)
  PLAYERHITBOX(1,1) = PLAYERX+1
  PLAYERHITBOX(1,2) = PLAYERY+8
  PLAYERHITBOX(2,1) = PLAYERX+16
  PLAYERHITBOX(2,2) = PLAYERY+8
  PLAYERHITBOX(3,1) = PLAYERX+1
  PLAYERHITBOX(3,2) = PLAYERY+16
  PLAYERHITBOX(4,1) = PLAYERX+16
  PLAYERHITBOX(4,2) = PLAYERY+16
?@(0,150) (1 + (PLAYERHITBOX(1,1) \ 8)), ((PLAYERHITBOX(1,2) \ 8)-7)

END SUB

SUB TILE8COLLIDE
'OFFSETS FOR TILES

TILETL = COLLISIONMAP(1 + (PLAYERHITBOX(1,1) \ 8), ((PLAYERHITBOX(1,2) \ 8)-7))
TILETR = COLLISIONMAP(1 + (PLAYERHITBOX(2,1) \ 8), ((PLAYERHITBOX(2,2) \ 8)-7))
TILEBL = COLLISIONMAP(1 + (PLAYERHITBOX(3,1) \ 8), ((PLAYERHITBOX(3,2) \ 8)-7))
TILEBR = COLLISIONMAP(1 + (PLAYERHITBOX(4,1) \ 8), ((PLAYERHITBOX(4,2) \ 8)-7))
COLLIDE = TILETL OR TILETR OR TILEBL OR TILEBR
TEXT 64, 24, STR$(TILETL) + " " + STR$(TILETR) + " " + STR$(TILEBL) + " " + STR$(TILEBR)

END SUB
    
'SCROLLS PLAYER IN ACCORDANCE WITH ROOM SCROLL
SUB SCROLLPLAYER(DIRECTION)
PAGE WRITE SPRITECOPYPAGE
SPRITE SHOW LINK, PLAYERX, PLAYERY, 0
  SELECT CASE DIRECTION
    CASE 1 : PLAYERY = PLAYERY + 13
    CASE 2 : PLAYERX = PLAYERX - 14
    CASE 3 : PLAYERY = PLAYERY - 13
    CASE 4 : PLAYERX = PLAYERX + 14
  END SELECT

PAGE COPY SPRITECOPYPAGE, SPRITEPAGE, B
END SUB

'THIS SUB IS GOING TO BE FOR CAVE ENTRANCES, ECT.
SUB TILEIDCOLLISION (TILECOL)
  SELECT CASE TILECOL
    CASE 37 :  
      COLLIDE = 1
      TEXT 8, 32 ,"TRUE"
    CASE ELSE
      COLLIDE = 0
      TEXT 8, 32 ,"FALSE"
  END SELECT
END SUB

'THIS SUB IS FOR GETTING THE TILE YOU ARE ON.
SUB GETTILESTANDING
    YOFFS = ((16+(PLAYERY)) \ 16) - 3  
    XOFFS = (( 8+(PLAYERX)) \ 16) + 1
  IF YOFFS > 16 OR YOFFS < 1 THEN
    YOFFS = 1 
  END IF
  IF XOFFS > 16 OR XOFFS < 1 THEN
    XOFFS = 1
  END IF  
    TILECOL = LEVEL(XOFFS, YOFFS)
  TEXT 8, 16, "TILE " + STR$(TILECOL)
END SUB

SUB GETTILEBOUNDS
  
  
END SUB

'SUB GETCOLLIDING(TILECOL, XOFFS, YOFFS)
'LOCAL INTEGER SX, SY, SW, SH
'SX = SPRITE(X,LINK)
'SY = SPRITE(Y,LINK) 
'SW = SPRITE(W,LINK)
'SH = SPRITE(H,LINK)
'text 8, 24, STR$(sx) + STR$(sy) + STR$(sw) + STR$(sh)

'  IF (((XOFFS-1)*16) > SX + SW OR ((XOFFS-1)*16)+16 < SX OR ((YOFFS+3)*16) < SY + SH OR ((YOFFS+3)*16)+16 > SY) THEN
  
'  SELECT CASE TILECOL
'      CASE 37 : 
'        COLLIDE = 1
'        TEXT 8, 32 ,"TRUE "
'      case 41 : 
'        collide = 1      
'      CASE ELSE :
'        COLLIDE = 0
'        TEXT 8, 32 ,"FALSE"
'    END SELECT
'END SUB


'SCROLLS ROOM IN DIRECTION OF PLAYER EDGE HIT
SUB ROOMEDGEHIT

  IF PLAYERY = ROOMTOP then
    SCROLLPLAYER(1)
    pause(64)
    ID = ID - 16
    PAUSE(64)
    READLEVEL(ID)
    LOADLEVEL(1)
    CHECKSTUCK(1)
  END IF
  
  IF PLAYERX = ROOMRIGHT -12 THEN
    SCROLLPLAYER(2)
    pause(64)
    ID = ID + 1
    PAUSE(64)
    READLEVEL(ID)
    LOADLEVEL(2)
    CHECKSTUCK(2)
  END IF

  IF PLAYERY = ROOMBOTTOM-17 THEN
    SCROLLPLAYER(3)
    pause(64)
    ID = ID + 16
    PAUSE(64)
    READLEVEL(ID)
    LOADLEVEL(3)
    CHECKSTUCK(3)
  END IF

  IF PLAYERX = ROOMLEFT-8 THEN
    SCROLLPLAYER(4)
    pause(64)
    ID = ID - 1
    PAUSE(64)
    READLEVEL(ID)
    LOADLEVEL(4)
    CHECKSTUCK(4)
  END IF
END SUB


'SCROLLS ONE WHOLE ROOM IN THE DIRECTION PRESSED.
SUB DEBUGSCROLLSCREENTRIGGER
  IF UPPRESS THEN
    PAUSE(64)
    ID = ID - 16  
    PAUSE(64)
    READLEVEL(ID)
    LOADLEVEL(1)
  END IF

  IF DOWNPRESS THEN
    PAUSE(64)
    ID = ID + 16
    PAUSE(64)
    READLEVEL(ID)
    LOADLEVEL(3)
  END IF

  IF LEFTPRESS THEN
    PAUSE(64)
    ID = ID - 1
    PAUSE(64)
    READLEVEL(ID)
    LOADLEVEL(4)
  END IF

  IF RIGHTPRESS THEN
    PAUSE(64)
    ID = ID + 1
    PAUSE(64)
    READLEVEL(ID)
    LOADLEVEL(2)
  END IF
END SUB
